************************************************************************
* Title : GLASSVIR.F    by      Armel Le Bail (1997)
* Notes : List neighbours for a selected i-j atom pair in *.imp
*         then create VRML-1 files 
*                      po.wrl          :  polyhedral rendering
*                      wi.wrl          :  wireframe rendering
*         and a POVRAY file
*                      glassvir.pov
*
*         Number maxi of atoms involved in polyhedra = 10000
*               (care : an atom can be in 2 polyhedra or more
*                if they share corners, then it will be counted
*                twice or more)
*
************************************************************************
*
      program glassvir
*
      parameter (max_atoms  =10000)
      parameter (max_types  =5)
      parameter (max_par    =max_types*(max_types+1)/2)
      parameter (max_neigh  =100)
*
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/CART,IO7,IO8,ICOL,NCOL
      DIMENSION CART(8,3),CART0(8,3),COOR(10000,3)
      INTEGER ICON(10000,2),NPOL(10000),NCO(10000),inn(100)
      DIMENSION ICOL(10000),NCOL(20,2),COLOR(20,3),NID(10000)
      real      atoms(3,max_atoms)
      real      vectors(3,3),metric(3,3),rbond(max_par),rminb(max_par)
      real      coords(3,max_neigh),d(max_neigh)
      integer   ni(max_types),ncum(max_types)
      integer   in(max_neigh)
      integer   preneigh(max_atoms,max_types)
      integer   fold(max_types,max_types,max_neigh+1)
      logical   truncated,tabline,qex
      character*80 infile,title,tmp
*
*     Read starting configuration
*
      write (*,10)
10    format (/' Neighbours and VRML files output (A. Le Bail, 1997)'/)
      write (*,'(1x,a,$)') 'Configuration file (no extension) ? '
      read (*,'(a)') infile
      lfile=len(infile)
      do while (infile(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
      tmp=infile(1:lfile)//'.cfg'
      call open_read1(3,tmp)
C      call open_read(3,infile,'.cfg')
      IO5=15
      IO7=16    
      INQUIRE(FILE='wi.wrl',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2013
      CALL FILEDEL(IO5,'wi.wrl')
2013  OPEN (IO5,FILE='wi.wrl',STATUS='NEW')
      INQUIRE(FILE='po.wrl',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2014
      CALL FILEDEL(IO7,'po.wrl')
2014  OPEN (IO7,FILE='po.wrl',STATUS='NEW')
      call read_config(title,ngen,ntried,nacc,nsaved,max_atoms,
     - max_types,truncated,vectors,n,ntypes,ni,atoms,3)
      close(3)
      ncum(1)=ni(1)
      do i=2,ntypes
         ncum(i)=ncum(i-1)+ni(i)
      enddo         
      do j=1,3
         do i=1,3
            metric(i,j)=0.
            do k=1,3
               metric(i,j)=metric(i,j)+vectors(k,i)*vectors(k,j)
            enddo
         enddo
      enddo
      npar=ntypes*(ntypes+1)/2
       do ic=1,npar
          rminb(ic)=0.
          rbond(ic)=0.
       enddo
      write (*,*) 'There are ',npar,' pairs of different atoms'
      write (*,'(1x,a,$)') 'Which one do you want to select ? '
      read (*,*) iselect
      write (*,'(1x,a,$)') 'Which central and neighbouring atoms ? '
      read (*,*) i00,i01
      write (*,'(1x,a,$)') 'Minimum and maximum bond lengths ? '
      read (*,*) rminb(iselect),rbond(iselect)
      write (*,'(1x,a,$)') 'Do you want a smaller box ? No=0, yes=1 '
      read (*,*)nbox
      noex=0
      if(nbox.eq.1)then
      noex=1
      write (*,'(1x,a,$)') 'New xmin, xmax, ymin, ymax, zmin, zmax ?'
      read (*,*)xmin,xmax,ymin,ymax,zmin,zmax       
      else      
      write (*,*) 'Extending the box along x, y, z by ? '
      write (*,'(1x,a,$)') '  +0.05 to +0.1 recommended : '
      read (*,*) ex
      endif
      bmax=0.
      do ic=1,npar
         bmax=max(bmax,rbond(ic))
      enddo
C      write (*,'(1x,a,$)') 'Output file           : '
C      read (*,'(a)') outfile
      tmp=infile(1:lfile)//'.imp'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.) go to 11
      print *,'warning, this old file will be deleted :',tmp
      call filedel(3,tmp)
11    call open_write1(3,tmp)
      write (*,*)
      write (*,*) 'Calculating neighbours ... '
      write (*,*)
*
      call makegrid(atoms,3,n,vectors,truncated)
*
      jcor=0
      jico=0
      ll=0
      itype=1
      do i=1,n
         if (i.gt.ncum(itype)) itype=itype+1
         if(itype.ne.i00)go to 100
      a1=(atoms(1,i)+1.)/2.
      a2=(atoms(2,i)+1.)/2.
      a3=(atoms(3,i)+1.)/2.
      if(nbox.eq.1)then
      if(a1.le.xmin.or.a1.gt.xmax)go to 100
      if(a2.le.ymin.or.a2.gt.ymax)go to 100
      if(a3.le.zmin.or.a3.gt.zmax)go to 100
      endif
      JCOR=JCOR+1
      if(jcor.gt.10000)then
      write(*,1001)
      STOP
      endif
      ll=ll+1
C  The central atom of the zarbi
      COOR(JCOR,1)=2.*(a1*vectors(1,1)+a2*vectors(1,2)+a3*vectors(1,3))
      COOR(JCOR,2)=2.*(a1*vectors(2,1)+a2*vectors(2,2)+a3*vectors(2,3))
      COOR(JCOR,3)=2.*(a1*vectors(3,1)+a2*vectors(3,2)+a3*vectors(3,3))
      NPOL(JCOR)=0
      NID(JCOR)=i
      JT=JCOR
         call neighbours(atoms,3,i,truncated,metric,
     -     bmax,1,n,in,coords,d,neigh)
C NPOLBZ is the number of corners in the zarbi polyhedron
         npolbz=0
         do j=1,neigh
            jtype=1
            do while (in(j).gt.ncum(jtype))
               jtype=jtype+1
            enddo
            if(jtype.ne.i01)go to 90
            i1=min(itype,jtype)
            j1=max(itype,jtype)
            ic=(i1-1)*(2*ntypes-i1)/2+j1
C            if (d(j).ge.rminb(ic).and.d(j).le.rbond(ic))
C     -         preneigh(i,jtype)=preneigh(i,jtype)+1
            if (d(j).lt.rminb(ic).and.d(j).gt.rbond(ic))go to 90
            npolbz=npolbz+1
            preneigh(i,jtype)=preneigh(i,jtype)+1
            inn(npolbz)=in(j)
90          continue
         enddo
C  The atoms at the zarbi corners
1001  format('  no more than 10000 atoms involved in polyhedra')
      IF(NPOLBZ.LE.2) then
      jcor=jcor-1
      ll=ll-1
      go to 100
      endif
      DO 205,II=1,NPOLBZ
      JCOR=JCOR+1
      if(jcor.gt.10000) then
      write(*,1001)
      STOP
      endif
      NPOL(JCOR)=NPOLBZ
      NID(JCOR)=i
      NCO(JCOR)=1
      JJ=INN(II)
      xx=1.
      IF((atoms(1,i)-atoms(1,jj)).GE.1.)xx=3.
      IF((atoms(1,i)-atoms(1,jj)).LE.-1.)xx=-1.
      yy=1.
      IF((atoms(2,i)-atoms(2,jj)).GE.1.)yy=3.
      IF((atoms(2,i)-atoms(2,jj)).LE.-1.)yy=-1.
      zz=1.
      IF((atoms(3,i)-atoms(3,jj)).GE.1.)zz=3.
      IF((atoms(3,i)-atoms(3,jj)).LE.-1.)zz=-1.
      COOR(JCOR,1)=2.*((atoms(1,JJ)+xx)/2.*vectors(1,1)+
     *(atoms(2,JJ)+yy)/2.*vectors(1,2)+(atoms(3,JJ)+zz)/2.*vectors(1,3))
      COOR(JCOR,2)=2.*((atoms(1,JJ)+xx)/2.*vectors(2,1)+
     *(atoms(2,JJ)+yy)/2.*vectors(2,2)+(atoms(3,JJ)+zz)/2.*vectors(2,3))
      COOR(JCOR,3)=2.*((atoms(1,JJ)+xx)/2.*vectors(3,1)+
     *(atoms(2,JJ)+yy)/2.*vectors(3,2)+(atoms(3,JJ)+zz)/2.*vectors(3,3))
      JICO=JICO+1
      ICON(JICO,1)=JT
      ICON(JICO,2)=JCOR
205   CONTINUE
100      continue
      enddo
      DO 206 I=1,3
      DO 206 J=1,7
206   CART0(J,I)=0.
      CART0(2,1)=1.
      CART0(3,3)=1.
      CART0(4,2)=1.
      CART0(5,1)=1.
      CART0(5,3)=1.
      CART0(6,1)=1.
      CART0(6,2)=1.
      CART0(7,2)=1.
      CART0(7,3)=1.
      DO 207 I=1,3
207   CART0(8,I)=1.
      DO 208,I=1,8
      CART(I,1)=2.*(cart0(I,1)*vectors(1,1)+
     *cart0(I,2)*vectors(1,2)+cart0(I,3)*vectors(1,3))
      CART(I,2)=2.*(cart0(I,1)*vectors(2,1)+
     *cart0(i,2)*vectors(2,2)+cart0(i,3)*vectors(2,3))
      CART(I,3)=2.*(cart0(i,1)*vectors(3,1)+
     *cart0(i,2)*vectors(3,2)+cart0(i,3)*vectors(3,3))
208   CONTINUE
      if(noex.eq.1) go to 3500
C
C Extension of the box by ex along x, y and z
C  (Works only in a Cartesian coordinate system)
C
C
      AX=CART(2,1)
      AY=CART(4,2)
      AZ=CART(3,3)
      I=0
      T=0.5-ex
      T2=1.-ex
      LLL=LL
      write(3,*)LL,'  polyhedra without extension'
      DO 3000 J=1,LLL
      I=I+1
C Test on central atom, is it outside the box X-ex, Y-ex, Z-ex
      CX=coor(i,1)/AX
      CY=coor(i,2)/AY
      CZ=coor(i,3)/AZ
      if(abs(CX-0.5).LT.T)then
      NX=0
      else
      NX=1
      endif
      if(abs(CY-0.5).LT.T)then
      NY=0
      else
      NY=1
      endif
      if(abs(CZ-0.5).LT.T)then
      NZ=0
      else
      NZ=1
      endif
C  Not a polyhedra on the cell boundary
      if(NX.EQ.0.AND.NY.EQ.0.AND.NZ.EQ.0) go to 2999
C  Now there are 3 cases 
C     1   NX and NY and NZ are equal to 1, then the polyhedra
C               is at one of the 8 corners and 7 should be
C               added by translation
C
C     2  Two of them are equal to 1, the polyhedra is at one
C        edge and then 3 should be added
C
C     3  Only one of them is equal to 1, the polyhedra has to
C        be doubled with only one
C
C   Case 3 :
      if(NX.EQ.1.AND.NY.EQ.0.AND.NZ.EQ.0) then
      AXS=AX
      if(CX.GE.T2)AXS=-AX
      CALL EXTENS(I,LL,AXS,0.,0.)
      endif
      if(NX.EQ.0.AND.NY.EQ.1.AND.NZ.EQ.0) then
      AYS=AY
      if(CY.GE.T2)AYS=-AY
      CALL EXTENS(I,LL,0.,AYS,0.)
      endif
      if(NX.EQ.0.AND.NY.EQ.0.AND.NZ.EQ.1) then
      AZS=AZ
      if(CZ.GE.T2)AZS=-AZ
      CALL EXTENS(I,LL,0.,0.,AZS)
      endif
C   Case 2 :
      if(NX.EQ.1.AND.NY.EQ.1.AND.NZ.EQ.0) then
      AXS=AX
      AYS=AY
      if(CX.GE.T2)AXS=-AX
      if(CY.GE.T2)AYS=-AY
      CALL EXTENS(I,LL,AXS,0.,0.)
      CALL EXTENS(I,LL,0.,AYS,0.)
      CALL EXTENS(I,LL,AXS,AYS,0.)
      endif
      if(NX.EQ.1.AND.NY.EQ.0.AND.NZ.EQ.1) then
      AXS=AX
      AZS=AZ
      if(CX.GE.T2)AXS=-AX
      if(CZ.GE.T2)AZS=-AZ
      CALL EXTENS(I,LL,AXS,0.,0.)
      CALL EXTENS(I,LL,0.,0.,AZS)
      CALL EXTENS(I,LL,AXS,0.,AZS)
      endif
      if(NX.EQ.0.AND.NY.EQ.1.AND.NZ.EQ.1) then
      AYS=AY
      AZS=AZ
      if(CY.GE.T2)AYS=-AY
      if(CZ.GE.T2)AZS=-AZ
      CALL EXTENS(I,LL,0.,AYS,0.)
      CALL EXTENS(I,LL,0.,0.,AZS)
      CALL EXTENS(I,LL,0.,AYS,AZS)
      endif
C  Case 1
      if(NX.EQ.1.AND.NY.EQ.1.AND.NZ.EQ.1) then
      AXS=AX
      AYS=AY
      AZS=AZ
      if(CX.GE.T2)AXS=-AX
      if(CY.GE.T2)AYS=-AY
      if(CZ.GE.T2)AZS=-AZ
      CALL EXTENS(I,LL,AXS,0.,0.)
      CALL EXTENS(I,LL,0.,AYS,0.)
      CALL EXTENS(I,LL,0.,0.,AZS)
      CALL EXTENS(I,LL,AXS,AYS,0.)
      CALL EXTENS(I,LL,0.,AYS,AZS)
      CALL EXTENS(I,LL,AXS,0.,AZS)
      CALL EXTENS(I,LL,AXS,AYS,AZS)
      endif
C
2999  I=I+NPOL(I+1)
3000  CONTINUE
      write(3,*)LL,'  polyhedra with extension by ',ex
C
C  NOW THE VRML OUTPUT
C
3500  CALL DEFCOL(COLOR)
      MCELL=1
      if(nbox.eq.1)then
      AX=(CART(2,1)*(xmax-xmin)/2.+CART(2,1)*xmin)*2.
      AY=(CART(4,2)*(ymax-ymin)/2.+CART(4,2)*xmin)*2.
      AZ=CART(3,3)*(zmax-zmin)
      endif
      CALL WRLWI(COLOR,MCELL,AX,AY,AZ)
      CALL WRLPO(COLOR,MCELL,LL,AX,AY,AZ)
      CALL WRLPOV(COLOR,MCELL,LL)
      itype=1
      do i=1,n
         if (i.gt.ncum(itype)) itype=itype+1
         do j=1,ntypes
            fold(itype,j,preneigh(i,j)+1) = 
     -        fold(itype,j,preneigh(i,j)+1)+1
         enddo
      enddo
      write (3,'(1x,a,a)')
     -  'Calculation of neighbours in ',infile
      write (3,*)
      write (3,'(1x,a,i1)') 'No. of atom types = ',ntypes
      write (3,*)
      write (3,*) 'Minimum bond lengths = ',(rminb(ic),ic=1,npar)
      write (3,*) 'Maximum bond lengths = ',(rbond(ic),ic=1,npar)
      write (3,*) 
C      do i=1,ntypes
C         do j=1,ntypes
      i=i00
      j=i01
            write (3,'(1x,a,i1,a,i1,a)')
     -        'Type ',i,' - Type ',j,' neighbours:'
            write (3,*)
            cdno=0.
            do k=1,max_neigh+1
               tabline=.false.
               if (fold(i,j,k).ne.0) then
                  tabline=.true.
                  quot=fold(i,j,k)*100./ni(i)
                  cdno=cdno+quot*(k-1)/100.
               endif
               if (tabline) write (3,'(1x,i10,i10,f10.3)')
     -            k-1,fold(i,j,k),quot
            enddo
            write (3,*)
            write (3,'(1x,a,f6.2)') 'Average coordination ',cdno
            write (3,*) '---------------------------'
C        enddo
C      enddo
      close(3)
*
      stop
      end
      SUBROUTINE EXTENS(I,LL,AXS,AYS,AZS)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/CART,IO7,IO8,ICOL,NCOL
      DIMENSION CART(8,3),COOR(10000,3)
      INTEGER ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION ICOL(10000),NCOL(20,2),NID(10000)
      JCOR=JCOR+1
      if(jcor.gt.10000)then
      write(*,1001)
      STOP
      endif
1001  format('  no more than 10000 atoms involved in polyhedra')
      ll=ll+1
C  The central atom of the zarbi
      COOR(JCOR,1)=COOR(I,1)+AXS
      COOR(JCOR,2)=COOR(I,2)+AYS
      COOR(JCOR,3)=COOR(I,3)+AZS
      NPOL(JCOR)=0
      NID(JCOR)=i+1000
      JT=JCOR
      NPOLBZ=NPOL(I+1)
      DO 1002,II=1,NPOLBZ
      JCOR=JCOR+1
      if(jcor.gt.10000) then
      write(*,1001)
      STOP
      endif
      NPOL(JCOR)=NPOLBZ
      NID(JCOR)=i+1000
      NCO(JCOR)=1
      COOR(JCOR,1)=COOR(I+II,1)+AXS
      COOR(JCOR,2)=COOR(I+II,2)+AYS
      COOR(JCOR,3)=COOR(I+II,3)+AZS
      JICO=JICO+1
      ICON(JICO,1)=JT
      ICON(JICO,2)=JCOR
1002  CONTINUE
      RETURN
      END
      subroutine makegrid(centres,ndim,n,vectors,truncated)
      real      centres(ndim,n),vectors(3,3)
      integer   gridsize
      logical   truncated
      parameter (gridsize=10,maxno=50,maxn=21000)
      integer*2 gridco(3,maxn)
      integer*2 grid(gridsize,gridsize,gridsize,maxno)
      integer*2 no(gridsize,gridsize,gridsize)
      common /grid/ grid,gridco,no,cellwidth
      save   /grid/
*
      if (n.gt.maxn) then
         write (*,*) 'Too many atoms for gridding routines'
         stop
      endif
*
      do i=1,gridsize
         do j=1,gridsize
            do k=1,gridsize
               no(i,j,k)=0
               do l=1,maxno
                  grid(i,j,k,l)=0
               enddo
            enddo
         enddo
      enddo
*
      do i=1,n
         ix=int((centres(1,i)+1.)*real(gridsize)/2.)+1
         iy=int((centres(2,i)+1.)*real(gridsize)/2.)+1
         iz=int((centres(3,i)+1.)*real(gridsize)/2.)+1
         ix=min(ix,gridsize)
         iy=min(iy,gridsize)
         iz=min(iz,gridsize)
         if (no(ix,iy,iz).eq.maxno) then
            write (*,*) 'Gridding error: Too many particles in grid box'
            stop
         else
            no(ix,iy,iz)=no(ix,iy,iz)+1
            grid(ix,iy,iz,no(ix,iy,iz))=i
            gridco(1,i)=ix
            gridco(2,i)=iy
            gridco(3,i)=iz
         endif
      enddo
*
*     Find shortest distance from centre of cell to a face
*
      triprod=vectors(1,1)*vectors(2,2)*vectors(3,3)
     -       +vectors(2,1)*vectors(3,2)*vectors(1,3)
     -       +vectors(3,1)*vectors(1,2)*vectors(2,3)
     -       -vectors(3,1)*vectors(2,2)*vectors(1,3)
     -       -vectors(2,1)*vectors(1,2)*vectors(3,3)
     -       -vectors(1,1)*vectors(3,2)*vectors(2,3)
      axb1=vectors(2,1)*vectors(3,2)-vectors(3,1)*vectors(2,2)
      axb2=vectors(3,1)*vectors(1,2)-vectors(1,1)*vectors(3,2)
      axb3=vectors(1,1)*vectors(2,2)-vectors(2,1)*vectors(1,2)
      bxc1=vectors(2,2)*vectors(3,3)-vectors(3,2)*vectors(2,3)
      bxc2=vectors(3,2)*vectors(1,3)-vectors(1,2)*vectors(3,3)
      bxc3=vectors(1,2)*vectors(2,3)-vectors(2,2)*vectors(1,3)
      cxa1=vectors(2,3)*vectors(3,1)-vectors(3,3)*vectors(2,1)
      cxa2=vectors(3,3)*vectors(1,1)-vectors(1,3)*vectors(3,1)
      cxa3=vectors(1,3)*vectors(2,1)-vectors(2,3)*vectors(1,1)
      d1=triprod/sqrt(axb1**2+axb2**2+axb3**2)
      d2=triprod/sqrt(bxc1**2+bxc2**2+bxc3**2)
      d3=triprod/sqrt(cxa1**2+cxa2**2+cxa3**2)
      dmax=min(d1,d2,d3)
      if (truncated) then
         d1=1.5*triprod/sqrt(
     -    (axb1+bxc1+cxa1)**2+(axb2+bxc2+cxa2)**2+(axb3+bxc3+cxa3)**2)
         d2=1.5*triprod/sqrt(
     -    (axb1-bxc1+cxa1)**2+(axb2-bxc2+cxa2)**2+(axb3-bxc3+cxa3)**2)
         d3=1.5*triprod/sqrt(
     -    (axb1+bxc1-cxa1)**2+(axb2+bxc2-cxa2)**2+(axb3+bxc3-cxa3)**2)
         d4=1.5*triprod/sqrt(
     -    (axb1-bxc1-cxa1)**2+(axb2-bxc2-cxa2)**2+(axb3-bxc3-cxa3)**2)
         dmax=min(dmax,d1,d2,d3,d4)
      endif
      cellwidth=2.*dmax/real(gridsize)
      return
      end


      subroutine updategrid(imove,xold,yold,zold,xnew,ynew,znew)
      integer   gridsize
      parameter (gridsize=10,maxno=50,maxn=21000)
      integer*2 gridco(3,maxn)
      integer*2 grid(gridsize,gridsize,gridsize,maxno)
      integer*2 no(gridsize,gridsize,gridsize)
      common /grid/ grid,gridco,no,cellwidth
      save   /grid/
*
      ix=int((xold+1.)*real(gridsize)/2.)+1
      iy=int((yold+1.)*real(gridsize)/2.)+1
      iz=int((zold+1.)*real(gridsize)/2.)+1
      ix=min(ix,gridsize)
      iy=min(iy,gridsize)
      iz=min(iz,gridsize)
      i1=1
      do while (grid(ix,iy,iz,i1).ne.imove)
         i1=i1+1
      enddo
      no(ix,iy,iz)=no(ix,iy,iz)-1
      do i=i1,no(ix,iy,iz)
         grid(ix,iy,iz,i)=grid(ix,iy,iz,i+1)
      enddo
      grid(ix,iy,iz,no(ix,iy,iz)+1)=0
      ix=int((xnew+1.)*real(gridsize)/2.)+1
      iy=int((ynew+1.)*real(gridsize)/2.)+1
      iz=int((znew+1.)*real(gridsize)/2.)+1
      ix=min(ix,gridsize)
      iy=min(iy,gridsize)
      iz=min(iz,gridsize)
      if (no(ix,iy,iz).eq.maxno) then
         write (*,*) 'Gridding error: Too many particles in grid box'
         stop
      endif
      no(ix,iy,iz)=no(ix,iy,iz)+1
      grid(ix,iy,iz,no(ix,iy,iz))=imove
      gridco(1,imove)=ix
      gridco(2,imove)=iy
      gridco(3,imove)=iz
      return
      end


      subroutine neighbours(centres,ndim,ic,truncated,metric,rmax,
     - n1,n2,in,coords,d,neigh)
      real      centres(ndim,*),coords(3,*),metric(3,3),d(*)
      integer   in(*)
      integer   gridsize,gridx,gridy,gridz
      logical   truncated
      parameter (gridsize=10,maxno=50,maxn=21000)
      integer*2 gridco(3,maxn)
      integer*2 grid(gridsize,gridsize,gridsize,maxno)
      integer*2 no(gridsize,gridsize,gridsize)
      common /grid/ grid,gridco,no,cellwidth
      save   /grid/
*
*     Finds neighbours. Returns coords in terms of unit cell vectors
*     and d (distance) in real units.
*
      neigh=0
      ng=int(rmax/cellwidth)+1
      gridx=gridco(1,ic)
      gridy=gridco(2,ic)
      gridz=gridco(3,ic)
      do ix=gridx-ng,gridx+ng
         iix=ix
         if (iix.le.0) iix=iix+gridsize
         if (iix.gt.gridsize) iix=iix-gridsize
         do iy=gridy-ng,gridy+ng
            iiy=iy
            if (iiy.le.0) iiy=iiy+gridsize
            if (iiy.gt.gridsize) iiy=iiy-gridsize
            do iz=gridz-ng,gridz+ng
               iiz=iz
               if (iiz.le.0) iiz=iiz+gridsize
               if (iiz.gt.gridsize) iiz=iiz-gridsize
               do ino=1,no(iix,iiy,iiz)
                  ig=grid(iix,iiy,iiz,ino)
                  if (ig.ge.n1.and.ig.le.n2.and.ig.ne.ic) then
                     x=centres(1,ig)-centres(1,ic)+3.
                     y=centres(2,ig)-centres(2,ic)+3.
                     z=centres(3,ig)-centres(3,ic)+3.
                     x=2.*(x/2.-int(x/2.))-1.
                     y=2.*(y/2.-int(y/2.))-1.
                     z=2.*(z/2.-int(z/2.))-1.
                     if (truncated.and.abs(x)+abs(y)+abs(z).gt.1.5) then
                        x=x-sign(1.,x)
                        y=y-sign(1.,y)
                        z=z-sign(1.,z)
                     endif
                     dd=metric(1,1)*x*x+metric(2,2)*y*y+metric(3,3)*z*z
     -                +2.*(metric(1,2)*x*y+metric(1,3)*x*z
     -                +metric(2,3)*y*z)
                     dd=sqrt(dd)
                     if (dd.lt.rmax) then
                        neigh=neigh+1
                        in(neigh)=ig
                        coords(1,neigh)=x
                        coords(2,neigh)=y
                        coords(3,neigh)=z
                        d(neigh)=dd
                     endif
                  endif
               enddo
            enddo
         enddo
      enddo
*
*     Now sort into order
*
      do i=1,neigh
         imin=i
         do j=i+1,neigh
            if (d(j).lt.d(imin)) imin=j
         enddo
         ini=in(imin)
         xd=coords(1,imin)
         yd=coords(2,imin)
         zd=coords(3,imin)
         dd=d(imin)
         in(imin)=in(i)
         coords(1,imin)=coords(1,i)
         coords(2,imin)=coords(2,i)
         coords(3,imin)=coords(3,i)
         d(imin)=d(i)
         in(i)=ini
         coords(1,i)=xd
         coords(2,i)=yd
         coords(3,i)=zd
         d(i)=dd 
      enddo
      return
      end

*     Subroutines are used for reading and writing RMC (or MD/MC) 
*     configuration files:
*
*     read_rmc_config   } general reading and writing routines
*     write_rmc_config  }
*
*     read_config       } simpler routines more appropriate
*     write_config      } for atomic systems
*
***********************************************************************

      subroutine read_rmc_config(title,ngen,ntried,nacc,nsaved,
     - max_molecules,max_moltypes,max_sites,nvar,
     - truncated,vectors,
     - nmol,nmoltypes,ni,nsites,sites,
     - neuler,centres,ichan)

      real          centres(nvar,max_molecules)
      real          sites(3,max_sites,max_moltypes)
      real          vectors(3,3)
      integer       ni(max_moltypes),nsites(max_moltypes)
      character*(*) title
      logical truncated,space
*
*     Reads a configuration data file
*
*     Check format of file
*     Also have to allow for possibility of initial space
*     (Fortran carriage control) which may or may not occur at
*     beginning of each line
*
      read (ichan,'(a)') title
      space=.false.
      if (title(1:1).eq.' ') space=.true.
      if (space) title=title(2:len(title))
      if (title(1:10).ne.'(Version 3') then
         write (*,*) 'Configuration file has wrong format'
         stop
      endif
*
      read (ichan,'(a)') title
      if (space) title=title(2:len(title))
      read (ichan,*) ngen,ntried,nacc
      read (ichan,*) nsaved
      read (ichan,*) nmol
      read (ichan,*) nmoltypes
      read (ichan,*) nsites_max
      read (ichan,*) neuler
*
      if (nmol.gt.max_molecules) then
         write (*,*) 'Configuration contains ',nmol,' particles'
         write (*,*) 'Arrays are only large enough for ',max_molecules
         stop
      endif
      if (nmoltypes.gt.max_moltypes) then
         write (*,*) 'Configuration contains ',nmoltypes,
     -     ' types of particle'
         write (*,*) 'Arrays are only large enough for ',max_moltypes
         stop
      endif
      if (nsites_max.gt.max_sites) then
         write (*,*) 'Configuration contains molecules with',nsites_max,
     -    'atomic sites'
         write (*,*) 'Arrays are only large enough for ',max_sites
         stop
      endif
      if (neuler+3.gt.nvar) then
         write (*,*) 'Configuration specifies ',neuler,' Euler angles'
         write (*,*) 'Arrays are only large enough for ',nvar-3
         stop
      endif
* 
      read (ichan,*)
      read (ichan,*) truncated
      read (ichan,*)
      read (ichan,*) vectors
*
      do itype=1,nmoltypes
         read (ichan,*) ni(itype)
         read (ichan,*) nsites(itype)
         read (ichan,*) ((sites(i,isite,itype),i=1,3),
     -    isite=1,nsites(itype))
      enddo
*
      do i=1,nmol
         read (ichan,*) (centres(j,i),j=1,3+neuler)
      enddo
      return
      end

***********************************************************************

      subroutine write_rmc_config(title,ngen,ntried,nacc,nsaved,
     - max_sites,nvar,
     - truncated,vectors,
     - nmol,nmoltypes,ni,nsites,sites,
     - neuler,centres,ichan)
      real          centres(nvar,*)
      real          sites(3,max_sites,*)
      real          vectors(3,3)
      integer       ni(*),nsites(*)
      character*(*) title
      logical truncated
*
*     Writes a configuration data file
*
      write (ichan,*) '(Version 3 format configuration file)'
      write (ichan,*) title
*
      write (ichan,*) 
      write (ichan,'(1x,3i10,a)') ngen,ntried,nacc,
     - ' moves generated, tried, accepted'
      write (ichan,'(1x,i10,20x,a)') nsaved,' configurations saved'
      write (ichan,*) 
      write (ichan,'(1x,i10,a)') nmol,' molecules (of all types)'
      write (ichan,'(1x,i10,a)') nmoltypes,' types of molecule'
      nsites_max=1
      do i=1,nmoltypes
         nsites_max=max(nsites_max,nsites(i))
      enddo
      write (ichan,'(1x,i10,a)') nsites_max,
     - ' is the largest number of atoms in a molecule'
      write (ichan,'(1x,i10,a)') neuler,' Euler angles are provided'
*
      write (ichan,*)
      if (truncated) then
         write (ichan,'(1x,l10,a)') truncated,
     -    ' (Box is truncated octahedral)'
      else
         write (ichan,'(1x,l10,a)') truncated,
     -    ' (Box is not truncated octahedral)'
      endif
      write (ichan,'(11x,a)') ' Defining vectors are:'
      write (ichan,'(3(11x,3(1x,f10.6)/))') vectors
*
      do itype=1,nmoltypes
         write (ichan,'(1x,i10,a,i2)') ni(itype),
     -     ' molecules of type ',itype
         write (ichan,'(1x,i10,a)') nsites(itype),' atomic sites'
         write (ichan,'(100(11x,3(1x,f10.6)/))')
     -    ((sites(i,isite,itype),i=1,3),isite=1,nsites(itype))
      enddo
*
      do i=1,nmol
         write (ichan,'(3(1x,f10.7),3(1x,f10.8))') 
     -    (centres(j,i),j=1,3+neuler)
      enddo
      return
      end

************************************************************************

      subroutine read_config(title,ngen,ntried,nacc,nsaved,
     - max_atoms,max_types,
     - truncated,vectors,
     - n,ntypes,ni,
     - atoms,ichan)
      real          atoms(3,max_atoms)
      real          vectors(3,3)
      integer       ni(*)
      real          sites(3,1,100)
      integer       nsites(100)
      character*(*) title
      logical truncated
*
      call read_rmc_config(title,ngen,ntried,nacc,nsaved,
     - max_atoms,max_types,1,3,truncated,vectors,
     - n,ntypes,ni,nsites,sites,neuler,atoms,ichan)
*
      return
      end

***********************************************************************

      subroutine write_config(title,ngen,ntried,nacc,nsaved,
     - truncated,vectors,n,ntypes,ni,atoms,ichan)
      real          atoms(3,*)
      real          vectors(3,3)
      integer       ni(*)
      real          sites(3,1,100)
      integer       nsites(100)
      character*(*) title
      logical truncated
*
      do i=1,ntypes
         nsites(i)=1
         sites(1,1,i)=0.
         sites(2,1,i)=0.
         sites(3,1,i)=0.
      enddo
      call write_rmc_config(title,ngen,ntried,nacc,nsaved,
     - 1,3,truncated,vectors,n,ntypes,ni,nsites,sites,
     - 0,atoms,ichan)
*
      return
      end

*      Contains the following machine dependent routines: 
*        rmc_init        initialises clock and random number generator
*        rmc_datafile    returns name of data file to be read
*        rmc_time        calculates CPU time used
*        rmc_rerun       passes RERUN flag to operating system
*        open_read       opens a file for reading
*        open_write      opens a file for writing 
*        real_to_hex     converts real*4 to IEEE hex string
*        hex_to_real     converts IEEE hex string to real*4
*
*-----------------------------------------------------------------------
*
*     Subroutine rmc_data must return the name of the data file to
*     be read by the programme. If possible this will be supplied
*     as a parameter on the command line that invokes the programme
*
C      subroutine rmc_datafile(file)
C      character*(*) file
C      call lib$get_foreign(file)
C      return
C      end
*
*-----------------------------------------------------------------------
*
*     Subroutine rmc_init must set the seed for the random number 
*     generator and obtain the current cpu clock reading in minutes
*
C      subroutine rmc_init(iseed,time_start)
C      include '($jpidef)'
C      iseed=int(secnds(0.))*2+1
C      call lib$getjpi(jpi$_cputim,,,iused)
C      time_start=real(iused)/6000.
C      return
C      end
*
*-----------------------------------------------------------------------
*
*     Subroutine rmc_time, given the initial cpu clock reading, must 
*     return the cpu time used (in minutes). If possible should return
*     a negative value if less than 1 minute remains.
*
*     VAX version is able to check CPU time left and if this is
*     less than 1 minute returns -time_used
*
C      subroutine rmc_time(time_start,time_used)
C      include '($jpidef)'
C      call lib$getjpi(jpi$_cputim,,,iused)
C      time_used=real(iused)/6000.-time_start
C      call lib$getjpi(jpi$_cpulim,,,limit)
C      left=(limit-iused)/100
C      if (limit.gt.0.and.left.lt.60) time_used=-time_used 
C      return
C      end
*
*-----------------------------------------------------------------------
*
*     Subroutine rmc_rerun, can be used to return the rerun flag to
*     the operating system, if desired.
*
C      subroutine rmc_rerun(rerun)
C      logical rerun
C      character true*4, false*5
C      data true,false/'TRUE','FALSE'/
C      if (rerun) then
C         call lib$set_symbol('RERUN',true)
C      else
C         call lib$set_symbol('RERUN',false)
C      endif
C      return
C      end
*
*-----------------------------------------------------------------------
*
*     Subroutine open_read opens a file for reading, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
C      subroutine open_read(unit,file,extension)
C      integer unit
C      character*(*) file,extension
C      open (unit,file=file,status='old',defaultfile=extension,
C     - readonly)
C      return
C      end
*
*-----------------------------------------------------------------------
*
*     Subroutine open_write opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
      subroutine open_write(unit,file,extension)
      integer unit
      character*(*) file,extension
      open (unit,file=file,status='new')
      return
      end
*
*-----------------------------------------------------------------------
*
*     Function real_to_hex converts a 32 bit real value to an
*     8 character hex string describing its internal representation.
*     If intermediate files are to be portable this must be
*     converted to IEEE form.
*
*     For VAX F_floating conversion to IEEE entails swapping top two
*     bytes with bottom two bytes and subtracting 2 from the exponent
*
      character*8 function real_to_hex(r)
      character*8 temp
      write (temp,'(z8)') r/4.
      do i=1,8
         if (temp(i:i).eq.' ') temp(i:i)='0'
      enddo
      real_to_hex(1:4)=temp(5:8)
      real_to_hex(5:8)=temp(1:4)
      i=1
      do while (real_to_hex(i:i).eq.'0'.and.i.le.7)
         real_to_hex(i:i)=' '
         i=i+1
      enddo
      return
      end
*
*-----------------------------------------------------------------------
*     Function hex_to_real converts an 8 character hex string in IEEE 
*     format to a 32 bit real value.
*
      real function hex_to_real(hex,error)
      character hex*(*),temp*8
      logical error
      error=.false.
      temp(1:4)=hex(5:8)
      temp(5:8)=hex(1:4)
      read (temp,'(z8)',end=10,err=10) hex_to_real
      hex_to_real=hex_to_real*4.
      return
10    error=.true.
      return
      end
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close (unit,status='delete')
      return
      end
C----------------------------------------------------------------------------
      SUBROUTINE WRLWI(COLOR,MCELL,AX,AY,AZ)
C  WIREFRAME MODEL wi.wrl
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/CART,IO7,IO8,ICOL,NCOL
      DIMENSION CART(8,3),COOR(10000,3)
      INTEGER ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION ICOL(10000),NCOL(20,2),COLOR(20,3),NID(10000)
      WRITE(IO5,1010)
      WRITE(IO5,1009)
      WRITE(IO5,2500)AX/2.,AY/2.,10.*AZ
      WRITE(IO5,1011)
      WRITE(IO5,1012)
      WRITE(IO5,999)
      WRITE(IO5,1013)
      WRITE(IO5,1011)
      WRITE(IO5,1011)
      WRITE(IO5,1015)
      DO 1,I=1,JCOR
      WRITE(IO5,1000)(COOR(I,J),J=1,3)
1     CONTINUE
      WRITE(IO5,1016)
      KCO=NCO(ICON(1,2))
      WRITE(IO5,1014)(COLOR(KCO,KK),KK=1,3)
      WRITE(IO5,1017)
      DO 2,I=1,JICO
      IF(NCO(ICON(I,2)).EQ.KCO)GO TO 100
      KCO=NCO(ICON(I,2))
      WRITE(IO5,1016)
      WRITE(IO5,1014)(COLOR(KCO,KK),KK=1,3)
      WRITE(IO5,1017)
100   WRITE(IO5,1001)(ICON(I,J)-1,J=1,2)
2     CONTINUE
      WRITE(IO5,1016)
      WRITE(IO5,1019)
      WRITE(IO5,1019)
C
C  DRAW CELL AXES
C
      IF(MCELL.GT.0)THEN
      WRITE(IO5,1020)
      WRITE(IO5,1011)
      WRITE(IO5,1015)
      DO 3,I=1,8
      WRITE(IO5,1000)(CART(I,J),J=1,3)
3     CONTINUE
      WRITE(IO5,1016)
      WRITE(IO5,1017)
      WRITE(IO5,1021)
      WRITE(IO5,1016)
      WRITE(IO5,1019)
      ENDIF
      WRITE(IO5,1019)
      RETURN
C WRITE VRML header
999   FORMAT('  ShapeHints { shapeType UNKNOWN_SHAPE_TYPE }')
1000  FORMAT(5X,3F8.3,',')
1001  FORMAT(1X,I4,',',I4,',-1,')
1009  FORMAT('DEF BackgroundColor Info { string "1. 1. 1." }')
1010  FORMAT('#VRML V1.0 ascii')
1011  FORMAT('Separator{')
1012  FORMAT('Info{string"Created by STRUVIR" }')
1013  FORMAT('Material{'/'ambientColor 0.1 0.1 0.1'/
     &'   diffuseColor 0.75 0.75 0.75'/'specularColor 0.9 0.9 0.9'/
     &'   shininess 0.8 }')
1014  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1015  FORMAT('Coordinate3{point[')
1016  FORMAT(1X,']}')
1017  FORMAT('IndexedLineSet{coordIndex[')
1019  FORMAT(1X,'}')
1020  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1021  FORMAT(1X,'0,1,4,2,0,3,5,7,6,3,-1,1,5,-1,2,6,-1,4,7,-1')
2500  FORMAT(1X,'PerspectiveCamera {'/10X,'position ',3F8.2/
     &10X,'heightAngle 0.2 }')
      END
C------------------------------------------------------------------                                        
      SUBROUTINE WRLPO(COLOR,MCELL,LL,AX,AY,AZ)
C  POLYHEDRA MODEL po.wrl
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/CART,IO7,IO8,ICOL,NCOL
      DIMENSION cart(8,3),COOR(10000,3)
      INTEGER ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION ICOL(10000),NCOL(20,2),COLOR(20,3),NID(10000)
      DIMENSION NI(3,220),MAR(200,2),NQ(4,20)
      WRITE(IO7,1010)
      WRITE(IO7,1009)
      WRITE(IO7,2500)AX/2.,AY/2,10.*AZ
      WRITE(IO7,1011)
      WRITE(IO7,1012)
      WRITE(IO7,999)
      WRITE(IO7,1013)
      WRITE(IO7,1011)
      WRITE(IO7,1011)
      I=0
      IPOL=1
1     I=I+1
      IF(I.GT.JCOR)GO TO 100
      IF(NPOL(I).LE.2)GO TO 1
      IF(NPOL(I).EQ.3)GO TO 30
      IF(NPOL(I).LE.20)GO TO 60
C  THEN NPOL(I).GT.20
      IF(NPOL(I).GT.20)GO TO 1
C
C  AX3 Polyhedron : draw X3 in their plane
C
30    WRITE(IO7,1005)NID(I)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 31 JJ=I,I+2
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
31     CONTINUE
      I=JJ
      IPOL=IPOL+1
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      WRITE(IO7,3050)
      WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      WRITE(IO7,3051)
      GO TO 1
C
C  AX4, to AX20 Polyhedron 
C
60    IA=I-1
      IB=I+NPOL(I)-1
C      IC=IPOL-MPOT
      IC=IPOL
      CALL FACED(IA,IB,NI,NT,IC,MAR,NAR,NQ,NS)
      WRITE(IO7,1005)NID(I)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 61 JJ=I,I+NPOL(I)-1
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
61    CONTINUE
      I=JJ
      IPOL=IPOL+1
      IF(NT.EQ.0)GO TO 71
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      IF(NT.EQ.1)GO TO 70
      DO 62 JJ=1,NT-1
      CALL ACLOC3(NI,JJ,IA+1)
      WRITE(IO7,5060)(NI(IN,JJ)-1,IN=1,3)
62    CONTINUE
70    CALL ACLOC3(NI,NT,IA+1)
      WRITE(IO7,5061)(NI(IN,NT)-1,IN=1,3)
71    IF(NS.EQ.0)GO TO 75
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      IF(NS.EQ.1)GO TO 74
      DO 73 JJ=1,NS-1
      CALL ACLOC4(NQ,JJ,IA+1)
      WRITE(IO7,5070)(NQ(IN,JJ)-1,IN=1,4)
73    CONTINUE
74    CALL ACLOC4(NQ,NS,IA+1)
      WRITE(IO7,5071)(NQ(IN,NS)-1,IN=1,4)
75    WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      DO 63 JJ=1,NAR-1
      WRITE(IO7,5062)MAR(JJ,1),MAR(JJ,2)
63    CONTINUE
      WRITE(IO7,5063)MAR(NAR,1),MAR(NAR,2)
      GO TO 1
100   WRITE(IO7,1019)
      WRITE(IO7,1019)
C
C DRAW SPHERES IF ANY
C
C      NOCIRC=0
C      DO 3000,I=9,NPT
C      IF(NCIRC(I).EQ.0) GO TO 3000
C      NOCIRC=NOCIRC+1
C3000  CONTINUE
C      IF(NOCIRC.EQ.0) GO TO 4000
C      WRITE(IO7,1011)
C      DO 3001,I=9,NPT
C      IF(NCIRC(I).EQ.0) GO TO 3001
C      WRITE(IO7,1011)
C      WRITE(IO7,3002)(COLOR(ICOL(I),KK),KK=1,3)
C      WRITE(IO7,3003)(CART(NCIRC(I),J),J=1,3)
C      WRITE(IO7,3004)
C3001  CONTINUE
C      WRITE(IO7,1019)
C
C  DRAW CELL AXES
C
4000  IF(MCELL.GT.0)THEN
      WRITE(IO7,1020)
      WRITE(IO7,1011)
      WRITE(IO7,1015)
      DO 4,I=1,8
      WRITE(IO7,1000)(CART(I,J),J=1,3)
4     CONTINUE
      WRITE(IO7,1016)
      WRITE(IO7,1017)
      WRITE(IO7,1021)
      WRITE(IO7,1016)
      WRITE(IO7,1019)
      ENDIF
      WRITE(IO7,1019)
      RETURN
C---------------------------------------------------------------------------
999   FORMAT('  ShapeHints { shapeType UNKNOWN_SHAPE_TYPE }')
1000  FORMAT(5X,3F8.3,',')
1001  FORMAT(1X,I4,',',I4,',-1,')
1005  FORMAT ('# POLYHEDRON ',I4)
1009  FORMAT('DEF BackgroundColor Info { string "1. 1. 1." }')
1010  FORMAT('#VRML V1.0 ascii')
1011  FORMAT('Separator{')
1012  FORMAT('Info{string"Created by STRUVIR" }')
1013  FORMAT('Material{'/'ambientColor 0.1 0.1 0.1'/
     &'   diffuseColor 0.75 0.75 0.75'/'specularColor 0.9 0.9 0.9'/
     &'   shininess 0.8 }')
1014  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1015  FORMAT('Coordinate3{point[')
1016  FORMAT(1X,']}')
1017  FORMAT('IndexedLineSet{coordIndex[')
1019  FORMAT(1X,'}')
1020  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1021  FORMAT(1X,'0,1,4,2,0,3,5,7,6,3,-1,1,5,-1,2,6,-1,4,7,-1')
1030  FORMAT('IndexedFaceSet{coordIndex[')
1040  FORMAT('0,1,2,-1,0,1,3,-1,0,2,3,-1,1,2,3,-1,')
1050  FORMAT('0,2,1,-1,0,1,3,-1,0,3,4,-1,0,4,2,-1,')
1051  FORMAT('5,2,1,-1,5,1,3,-1,5,3,4,-1,5,4,2,-1,')
1060  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
2000  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
2001  FORMAT('0,1,2,0,3,1,-1,2,3,-1 ]}')
2002  FORMAT('0,1,5,4,3,1,2,4,0,3,5,2,0,-1 ]}')
2500  FORMAT(1X,'PerspectiveCamera {'/10X,'position ',3F8.2/
     &10X,'heightAngle 0.2 }')
3002  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
3003  FORMAT('Translation{translation '3F8.3' }')
3004  FORMAT('Sphere{radius 0.5 } }')
3050  FORMAT('0,2,1,-1,')
3051  FORMAT('0,1,2,0,-1 ]}')
4050  FORMAT('0,2,1,-1,0,3,1,-1')
4051  FORMAT('0,2,1,3,0,-1 ]}')
5050  FORMAT('0,2,3,-1,0,3,4,-1,0,4,2,-1,1,2,3,-1,1,3,4,-1,1,4,2,-1')
5051  FORMAT('2,3,4,2,1,4,0,3,1,-1,0,2,-1 ]}')
5060  FORMAT(3(I2',')'-1,')
5061  FORMAT(3(I2',')'-1')
5062  FORMAT(2(I2',')'-1,')
5063  FORMAT(2(I2',')'-1 ]}')
5070  FORMAT(4(I2',')'-1,')
5071  FORMAT(4(I2',')'-1')
      END

C-----------------------------------------------------------------------
C  The ACLOC3 subroutine performs surface tests for triangles
C
      SUBROUTINE ACLOC3(NI,JJ,I)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(10000,3),ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION NID(10000),NI(3,220),NTEMP(3),X(3),Y(3),Z(3)
      DO 100 J=1,3
      X(J)=COOR(I+NI(J,JJ)-1,1)
      Y(J)=COOR(I+NI(J,JJ)-1,2)
100   Z(J)=COOR(I+NI(J,JJ)-1,3)
      P1=Z(1)*Y(2)-Y(1)*Z(2)
      P2=X(1)*Z(2)-Z(1)*X(2)
      P3=Y(1)*X(2)-X(1)*Y(2)
      C=X(3)*P1+Y(3)*P2+Z(3)*P3
C      WRITE(4,*)'Triangular face JJ,  C  =',JJ,C
C
C OPTION: C must be negative otherwise reverse order
C 
      IF(C.LT.0.) GO TO 200
      DO 150 J=1,3
150   NTEMP(3-J+1)=NI(J,JJ)
      DO 151 J=1,3
151   NI(J,JJ)=NTEMP(J)
200   CONTINUE   
      RETURN
      END
C
C  The ACLOC4 subroutine performs surface tests for squares
C
      SUBROUTINE ACLOC4(NQ,JJ,I)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(10000,3),ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION NID(10000),NQ(4,20),NTEMP(4),X(3),Y(3),Z(3)
      DO 100 J=1,3
      X(J)=COOR(I+NQ(J,JJ)-1,1)
      Y(J)=COOR(I+NQ(J,JJ)-1,2)
100   Z(J)=COOR(I+NQ(J,JJ)-1,3)
      P1=Z(1)*Y(2)-Y(1)*Z(2)
      P2=X(1)*Z(2)-Z(1)*X(2)
      P3=Y(1)*X(2)-X(1)*Y(2)
      C=X(3)*P1+Y(3)*P2+Z(3)*P3
C      WRITE(4,*)'Square face JJ,  C  =',JJ,C
C
C OPTION: C must be negative otherwise reverse order
C 
      IF(C.LT.0.) GO TO 200
      DO 150 J=1,4
150   NTEMP(4-J+1)=NQ(J,JJ)
      DO 151 J=1,4
151   NQ(J,JJ)=NTEMP(J)
200   CONTINUE   
      RETURN
      END
C
C The GEOM subroutine places first of the list the coordinates
C          of the X1 and X2 atoms having the largest X1-M-X2
C          angle in the MXn polyhedron  (n.LE.12). Then X3 and
C          X4 with the shortest X3-M-X4 angles will be listed,
C          unless X3 or X4 is identical to X1 or X2 so only the
C          third group of coordinates will correspond to either
C          X3-M-X1 or X3-M-X2 with shortest angle.
C
C Moreover : NS may have several values according to the
C            polyhedron type :
C            MX5 : NS=3 if triangular bipyramid defined as
C                  3 angles in the range 90-135 
C
      SUBROUTINE GEOM(I,IJ,NS)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(10000,3),ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION YZ(100,5),YE(200,5),NID(10000),CO(12,3),MH(20)
C
      YC36=57.29578
      LL=0
      NS=0
      DO 4 J=I+1,IJ
      LL=LL+1
      YZ(LL,1)=FLOAT(J)
      YZ(LL,2)=COOR(I,1)-COOR(J,1)
      YZ(LL,3)=COOR(I,2)-COOR(J,2)
      YZ(LL,4)=COOR(I,3)-COOR(J,3)
      YZ(LL,5)=SQRT(YZ(LL,2)*YZ(LL,2)+
     *             YZ(LL,3)*YZ(LL,3)+
     *             YZ(LL,4)*YZ(LL,4))
    4 CONTINUE
      TEST1=0.
      TEST2=180.
      II=0
      DO 13 J=1,LL-1
      DO 12 K=J+1,LL
      II=II+1
      YE(II,1)=YZ(J,1)
      YE(II,2)=YZ(K,1)
      MH(8)=IFIX(YE(II,2))
      MH(7)=IFIX(YE(II,1))
      IF (ABS(YZ(J,5)*YZ(K,5)).GE.1E-8)THEN
        ARCO=(YZ(J,2)*YZ(K,2)+YZ(J,3)*YZ(K,3)+YZ(J,4)*YZ(K,4))/
     &  (YZ(J,5)*YZ(K,5))
        IF(ARCO.GT. 1.)ARCO= 1.
        IF(ARCO.LT.-1.)ARCO=-1.
      ELSE
        ARCO=1.
      ENDIF
      YE(II,3)=ACOS(ARCO)*YC36
      IF(YE(II,3).LT.135.AND.YE(II,3).GT.90.)NS=NS+1
      IF(YE(II,3).LT.TEST1)GO TO 120
      TEST1=YE(II,3)
      M1=MH(8)
      M2=MH(7)
120   IF(YE(II,3).GT.TEST2)GO TO 12
      TEST2=YE(II,3)
      M3=MH(8)
      M4=MH(7)
   12 CONTINUE
   13 CONTINUE
      CO(1,1)=COOR(M1,1)
      CO(1,2)=COOR(M1,2)
      CO(1,3)=COOR(M1,3)
      CO(2,1)=COOR(M2,1)
      CO(2,2)=COOR(M2,2)
      CO(2,3)=COOR(M2,3)
      LL=2
      IF(M3.EQ.M1.OR.M3.EQ.M2)GO TO 131
      CO(LL+1,1)=COOR(M3,1)
      CO(LL+1,2)=COOR(M3,2)
      CO(LL+1,3)=COOR(M3,3)
      M5=M3
      LL=LL+1
131   IF(M4.EQ.M1.OR.M4.EQ.M2)GO TO 132
      CO(LL+1,1)=COOR(M4,1)
      CO(LL+1,2)=COOR(M4,2)
      CO(LL+1,3)=COOR(M4,3)
      M5=M4
      LL=LL+1
132   IF(LL.NE.4) GO TO 133
      DO 14 J=I+1,IJ
      IF(M1.EQ.J)GO TO 14
      IF(M2.EQ.J)GO TO 14
      IF(M3.EQ.J)GO TO 14
      IF(M4.EQ.J)GO TO 14
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
   14 CONTINUE
      GO TO 140
133   DO 139 J=I+1,IJ
      IF(M1.EQ.J)GO TO 139
      IF(M2.EQ.J)GO TO 139
      IF(M5.EQ.J)GO TO 139
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
139   CONTINUE
140   LL=0
      DO 15 J=I+1,IJ
      LL=LL+1
      COOR(J,1)=CO(LL,1)
      COOR(J,2)=CO(LL,2)
      COOR(J,3)=CO(LL,3)
   15 CONTINUE
      RETURN
      END
C
C The FACED subroutine recovers edges and faces for the
C            bizarre polyhedra
C           
      SUBROUTINE FACED(I,IJ,NI,NT,LL,MAR,NAR,NQ,NS)
C
C  I  is the ID number for the central atom coordinates COOR(I,3)
C  from j = I+1 to IJ are the ID numbers for the polyhedron
C                     vertices coordinates
C  NI(3,1 to NT) will contain the triangle vertices numbers in return
C  NQ(3,1 to NS) will contain the square vertices numbers in return
C  MAR(1 to NAR,2) will contain edges
C
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(10000,3),ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION CO(12,3),NID(10000),NQ(4,20),N(15)
      DIMENSION NI(3,220),MAR(200,2),MVV(12),ICODE(220),C(220)
C
      CALL EDGE(LL,MAR,NAR,MVV)
      LL=0
      DO 4 J=I+1,IJ
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
    4 CONTINUE
C
C      THEN: find all possible triangle XJ-XK-XL
      NT=0
      DO 150 J=1,LL-2
      DO 140 K=J+1,LL-1
      DO 130 L=K+1,LL
      IF(K.EQ.L)GO TO 130
      NT=NT+1
      NI(1,NT)=J
      NI(2,NT)=K
      NI(3,NT)=L
C      WRITE(4,*)'NT N1 N2,N3',NT,J,K,L
130   CONTINUE
140   CONTINUE
150   CONTINUE
C
C Find those triangles at the polyhedron surface
C            by the "brute force" 
C
      DO 160 KK=1,NT
160   ICODE(KK)=0
      DO 300 KK=1,NT
      J=NI(1,KK)
      K=NI(2,KK)
      L=NI(3,KK)
      X1=CO(K,1)-CO(J,1)
      Y1=CO(K,2)-CO(J,2)
      Z1=CO(K,3)-CO(J,3)
      X2=CO(L,1)-CO(J,1)
      Y2=CO(L,2)-CO(J,2)
      Z2=CO(L,3)-CO(J,3)
      P1=Y1*Z2-Y2*Z1
      P2=X2*Z1-X1*Z2
      P3=X1*Y2-X2*Y1
      DO 290 KL=1,NT
      IF(KL.EQ.KK)C(KL)=0.
      IF(KL.EQ.KK)GO TO 290
C
C X3,Y3,Z3 are coordinates of a vector pointing from
C   the barycenter of the face KL toward a vertex of the face KK
C
      X3=(CO(NI(1,KL),1)+CO(NI(2,KL),1)+CO(NI(3,KL),1))/3.
      Y3=(CO(NI(1,KL),2)+CO(NI(2,KL),2)+CO(NI(3,KL),2))/3.
      Z3=(CO(NI(1,KL),3)+CO(NI(2,KL),3)+CO(NI(3,KL),3))/3.
      X3=CO(J,1)-X3
      Y3=CO(J,2)-Y3
      Z3=CO(J,3)-Z3
      C(KL)=X3*P1+Y3*P2+Z3*P3
C      WRITE(4,*)'KK KL C',KK,KL,C
      IF(ABS(C(KL)).LT.0.0001)C(KL)=0.
      DO 280 KKK=1,KL
      IF(C(KKK).EQ.0.)GO TO 280
      IF(C(KL).EQ.0.)GO TO 280
C If signs are different go to 300
      IF(C(KL)*C(KKK).LT.0.)GO TO 300
280   CONTINUE
290   CONTINUE
      ICODE(KK)=1
300   CONTINUE
      IT=0
      DO 310 KK=1,NT
      IF(ICODE(KK).EQ.0)GO TO 310
      IT=IT+1
      ICODE(IT)=1
      NI(1,IT)=NI(1,KK)
      NI(2,IT)=NI(2,KK)
      NI(3,IT)=NI(3,KK)
C     WRITE(4,*)'IT N1 N2 N3',IT,NI(1,IT),NI(2,IT),NI(3,IT)
310   CONTINUE
      NT=IT
      IF(NS.EQ.0)GO TO 501
      IT=0
      DO 500 KK=1,NT
      IF(ICODE(KK).EQ.0)GO TO 500
      IT=IT+1
      NI(1,IT)=NI(1,KK)
      NI(2,IT)=NI(2,KK)
      NI(3,IT)=NI(3,KK)
C      WRITE(4,*)'IT N1 N2 N3',IT,NI(1,IT),NI(2,IT),NI(3,IT)
500   CONTINUE
      NT=IT
501   CONTINUE
C
C  Are some edge lacking ... ?
C
      LL=IJ-I
      DO 1010 JJ=1,NAR
      DO 1010 J=1,LL
      IF(MAR(JJ,1).EQ.MVV(J))MAR(JJ,1)=J
      IF(MAR(JJ,2).EQ.MVV(J))MAR(JJ,2)=J
1010  CONTINUE
      DO 600 KL=1,NT
      N1=NI(1,KL)
      N2=NI(2,KL)
      N3=NI(3,KL)
      DO 590 JJ=1,NAR
      N4=MAR(JJ,1)
      N5=MAR(JJ,2)
      IF(N4.EQ.N1.AND.N5.EQ.N2)GO TO 591
      IF(N4.EQ.N2.AND.N5.EQ.N1)GO TO 591
590   CONTINUE
      IF(NAR.GT.200)PRINT *,'MORE THAN 200 EDGES =STOP'
      IF(NAR.GT.200)STOP
      NAR=NAR+1
      MAR(NAR,1)=N1
      MAR(NAR,2)=N2
591   CONTINUE
      DO 592 JJ=1,NAR
      N4=MAR(JJ,1)
      N5=MAR(JJ,2)
      IF(N4.EQ.N2.AND.N5.EQ.N3)GO TO 593
      IF(N4.EQ.N3.AND.N5.EQ.N2)GO TO 593
592   CONTINUE
      NAR=NAR+1
      IF(NAR.GT.200)PRINT *,'MORE THAN 200 EDGES =STOP'
      IF(NAR.GT.200)STOP
      MAR(NAR,1)=N2
      MAR(NAR,2)=N3
593   CONTINUE
600   CONTINUE
      DO 1011 L=1,NAR
      MAR(L,1)=MAR(L,1)-1
      MAR(L,2)=MAR(L,2)-1
1011  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EDGE(LL,MAR,NAR,MVV)
      COMMON/ALL1/YA(4,10000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(10,2),MM(70),MN(1000,8),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
      DIMENSION MAR(200,2),MVV(12)
C
      MG(10)=LL
      I=0
      M=MV(MG(10),14)
      DO 106 K=2,MU(M,1,3)+1
      DO 135 L=1,MU(M,K,7)
      JJ=MOD(L,MU(M,K,7))+1
      N1=MU(M,K,L)
      N2=MU(M,K,JJ)
      DO 137 NN=1,I
      IF(MA(NN,1).EQ.MV(MG(10),N1).AND.MA(NN,2).EQ.MV(MG(10),N2))
     * GOTO 135
      IF(MA(NN,2).EQ.MV(MG(10),N1).AND.MA(NN,1).EQ.MV(MG(10),N2))
     * GOTO 135
  137 CONTINUE
      I=I+1
      MA(I,1)=MV(MG(10),N1)
      MA(I,2)=MV(MG(10),N2)
      MAR(I,1)=MV(MG(10),N1)
      MAR(I,2)=MV(MG(10),N2)
  135 CONTINUE
  106 CONTINUE
  132 IF(I.EQ.20) GOTO 139
      DO 140 J=I+1,20
      MA(J,1)=0
  140 MA(J,2)=0
  139 CONTINUE
      NAR=I
      DO 200 J=1,12
200   MVV(J)=MV(MG(10),J)
      RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE DEFCOL(C)
      DIMENSION C(20,3)
C  Blue sky
      C(1,1)=0.0
      C(1,2)=1.0
      C(1,3)=1.0
C  Green light
      C(2,1)=0.5
      C(2,2)=1.5
      C(2,3)=0.0
C  Red pyrope
      C(3,1)=1.0
      C(3,2)=0.1
      C(3,3)=0.5
C  Yellow
      C(4,1)=1.0
      C(4,2)=1.0
      C(4,3)=0.0
C  Blue grey
      C(5,1)=0.6
      C(5,2)=0.6
      C(5,3)=1.0
C  Orange
      C(6,1)=1.0
      C(6,2)=0.6
      C(6,3)=0.0
C  Purple
      C(7,1)=0.5
      C(7,2)=0.0
      C(7,3)=0.5
C  Brown
      C(8,1)=0.5
      C(8,2)=0.3
      C(8,3)=0.0
C  Blue-green-dark
      C(9,1)=0.0
      C(9,2)=0.5
      C(9,3)=0.5
C  Red
      C(10,1)=1.0
      C(10,2)=0.0
      C(10,3)=0.0
C  Green
      C(11,1)=0.0
      C(11,2)=1.0
      C(11,3)=0.0
C  Blue
      C(12,1)=0.0
      C(12,2)=0.0
      C(12,3)=1.0
C  Pink
      C(13,1)=1.0
      C(13,2)=0.0
      C(13,3)=1.0
C  Red dark
      C(14,1)=0.5
      C(14,2)=0.0
      C(14,3)=0.0
C  Green dark
      C(15,1)=0.0
      C(15,2)=0.5
      C(15,3)=0.0
C  Blue night
      C(16,1)=0.0
      C(16,2)=0.0
      C(16,3)=0.5
C  Red wine
      C(17,1)=0.5
      C(17,2)=0.05
      C(17,3)=0.25
C  White
      C(18,1)=1.0
      C(18,2)=1.0
      C(18,3)=1.0
C  Grey
      C(19,1)=0.5
      C(19,2)=0.5
      C(19,3)=0.5
C  Black
      C(20,1)=0.0
      C(20,2)=0.0
      C(20,3)=0.0
      RETURN
      END
C---------------------------------------------------------------------------
C Writes polyhedron model in POVRAY-format to file
C Mark Koennecke July 1996
C no warranties taken 
C Free for non commercial usage 
C----------------------------------------------------------------------------                                        
      SUBROUTINE WRLPOV(COLOR,MCELL,LL)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/CART,IO7,IO8,ICOL,NCOL
      DIMENSION cart(8,3),COOR(10000,3)
      INTEGER ICON(10000,2),NPOL(10000),NCO(10000)
      DIMENSION ICOL(10000),NCOL(20,2),COLOR(20,3),NID(10000)
      DIMENSION NI(3,220),MAR(200,2),NQ(4,20)
      INTEGER IOPOV, I	
      CHARACTER*20 COLNAM	
      LOGICAL T	
      REAL MIN(3), MAX(3),MIT(3), DIS
      INTEGER U,UU	

C create a file
      IOPOV = 27	
      INQUIRE(FILE='glassvir.pov',EXIST=T)
      IF(T)THEN	
	      CALL FILEDEL(IOPOV,'glassvir.pov')
      END IF
      OPEN(IOPOV,FILE='glassvir.pov',STATUS='NEW')      	
C create a header
      WRITE(IOPOV,2001)
 2001 FORMAT('/*------------------------------------------------')
      WRITE(IOPOV,*)' POVRAY input file created by STRUPLO'
      WRITE(IOPOV,*)' STRUPLO is a crystal structure plotting package'
      WRITE(IOPOV,*)' Courtesy by Reinhard Fischer'
      WRITE(IOPOV,*)' Modified to produce POVRAY output by:'
      WRITE(IOPOV,*)' Dr. Mark Koennecke PSI'
      WRITE(IOPOV,*)' July 1996 '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)' The following declares provide default properties'
      WRITE(IOPOV,*)' for the polygons. The default is stupid color    '
      WRITE(IOPOV,*)' By editing these declares, the properties of '
      WRITE(IOPOV,*)' polygons can easily be adapted for groups of '
      WRITE(IOPOV,*)' Atoms respective polygons '
      WRITE(IOPOV,2002)
 2002 FORMAT('------------------------------------------------------*/')

C write declares with colours
        DO 2010, I = 1, 20			  	 			
        WRITE(COLNAM,2003)I
 2003   FORMAT('PolyTyp',I2.2)
        WRITE(IOPOV,2004)COLNAM
 2004   FORMAT(' #declare ',A20,' = ')
        WRITE(IOPOV,2005)COLOR(I,1),COLOR(I,2),COLOR(I,3)
 2005   FORMAT('  texture { pigment {color rgb < ',3(F6.3,1X),' > }')
        WRITE(IOPOV,*)'      finish {ambient 0.5 } }'
 2010 CONTINUE

C find center of data for positioning the camera sensibly
      DO 6000, U = 1, 3
	MIN(U) = 999999.
        MAX(U) = -999999.
 6000 CONTINUE
      DO 6010, U = 1, JCOR
	DO 6020, UU = 1,3
          IF(COOR(U,UU) .GT. MAX(UU))MAX(UU) = COOR(U,UU)
          IF(COOR(U,UU) .LT. MIN(UU))MIN(UU) = COOR(U,UU)
 6020   CONTINUE
 6010 CONTINUE
      DO 6030, U = 1, 3
        MIT(U) = MAX(U) - (ABS(MAX(U) - MIN(U))/2)
 6030 CONTINUE 

C get distance: find extent and assume 30degree camera angle
      DIS = ABS(MAX(1)-MIN(1))
      IF(ABS(MAX(2)-MIN(2)) .GT. DIS)DIS = ABS(MAX(2)-MIN(2))
      DIS = DIS /.5777 	

C write the default camera
      WRITE(IOPOV,*)' camera {'
      WRITE(IOPOV,6031)MIT(1), MIT(2), DIS
 6031 FORMAT('        location  < ',2(F8.4,',',1X),F8.4,' >')
      WRITE(IOPOV,6032)(MIT(U), U = 1,3)
 6032 FORMAT('        look_at  < ',2(F8.4,',',1X),F8.4,' >')
      WRITE(IOPOV,*)' }'			

C the default light source
      WRITE(IOPOV,*)' light_source { < 80., 0., 0.>'
      WRITE(IOPOV,*)'           color rgb <1.,1.,1.>}'

      I=0
      IPOL=1
C start loop
1     I=I+1
      IF(I.GT.JCOR)GO TO 100
      IF(NPOL(I).EQ.0)GO TO 1
      IF(NPOL(I).EQ.1)GO TO 1
      IF(NPOL(I).EQ.2)GO TO 1
      IF(NPOL(I).EQ.3)GO TO 30
      IF(NPOL(I).LE.20)GO TO 60
C  THEN NPOL(I).GT.20
      IF(NPOL(I).GT.20)GO TO 1
C
C  AX3 Polyhedron : draw X3 in their plane
C
30    WRITE(IOPOV,2030)NID(I)
 2030 FORMAT(' // AX3 Polyhedron ', I4)
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)	
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,2022)COLNAM 
      I = I + 2
      IPOL = IPOL + 1
      GO TO 1
C
C  AX4 to AX20 Polyhedron
C
60    IA=I-1
      IF(NPOL(I).EQ.16)NPOL(I)=6
      IB=I+NPOL(I)-1
      IC=IPOL
      CALL FACED(IA,IB,NI,NT,IC,MAR,NAR,NQ,NS)
      WRITE(IOPOV,2012)NID(I)
 2012 FORMAT(' // General polyhedron  ', I4, 2X, 2A1)
 2021 FORMAT('     < ',2(1X,F8.4,','),F8.4,' > , ')
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)
 3009 FORMAT(' union { ')
      I= I + NPOL(I) - 1
      IPOL=IPOL+1
      IF(NT.EQ.0)GO TO 71
      IF(NT.EQ.1)GO TO 70
      DO 62 JJ=1,NT-1
      CALL ACLOC3(NI,JJ,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NI(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NI(2,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NI(3,JJ),J), J=1,3)
62    CONTINUE
70    CALL ACLOC3(NI,NT,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NI(1,NT),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NI(2,NT),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NI(3,NT),J), J=1,3)
71    IF(NS.EQ.0)GO TO 75
      IF(NS.EQ.1)GO TO 74
      DO 73 JJ=1,NS-1
      CALL ACLOC4(NQ,JJ,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(2,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(3,JJ),J), J=1,3)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(3,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(4,JJ),J), J=1,3)
73    CONTINUE
74    CALL ACLOC4(NQ,NS,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,NS),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(2,NS),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(3,NS),J), J=1,3)
 3001 FORMAT('     < ',2(1X,F8.4,','),F8.4,' > }')
 2022 FORMAT('    texture { ',A20, ' }   } ')
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,NS),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(3,NS),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(4,NS),J), J=1,3)
75    CONTINUE
      WRITE(IOPOV,2022)COLNAM 
      GO TO 1
100   WRITE(IOPOV,*)' '
      WRITE(IOPOV,*)' '
C
C DRAW SPHERES IF ANY
C
C      WRITE(IOPOV,*)' // Drawing spheres ........'
C      NOCIRC=0
C      DO 3000,I=9,NPT
C      IF(NCIRC(I).EQ.0) GO TO 3000
C      NOCIRC=NOCIRC+1
C3000  CONTINUE
C      IF(NOCIRC.EQ.0) GO TO 4000
C      DO 3002,I=9,NPT
C      IF(NCIRC(I).EQ.0) GO TO 3002
C      WRITE(IOPOV,2040)
 2040 FORMAT(' sphere { ')
C      WRITE(COLNAM,2003)ICOL(I)
C      WRITE(IOPOV,2041)(CART(NCIRC(I),J),J=1,3)
 2041 FORMAT('         < ',2(1X,F8.4,','),1X,F8.4, ' >, 0.7 ')
C      WRITE(IOPOV,2042)COLNAM
 2042 FORMAT('       texture { ',A20,'} } ')	
 3002 CONTINUE
 4000 CONTINUE
      WRITE(IOPOV,*)' // end of file '
      CLOSE(IOPOV)	
      RETURN
      END




